"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _jsCookie = _interopRequireDefault(require("js-cookie"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Cookie =
/*#__PURE__*/
function () {
  /**
   * @ignore
   */
  function Cookie() {
    _classCallCheck(this, Cookie);

    _jsCookie.default.defaults = {
      domain: document.domain.split('.').slice(-2).join('.'),
      path: '/',
      expires: 365
    };
  }
  /**
   * 获取cookie
   * @param  {?string} key cookie键值
   * @return {string|Object}     返回key对应的value，不传key，则返回所有cookie的键值对
   */


  _createClass(Cookie, [{
    key: "get",
    value: function get(key) {
      return _jsCookie.default.get(key);
    }
    /**
     * 获取cookie，使用方式同get方法，返回的value是通过JSON.parse解析后的
     * @param  {?string} key cookie键值
     * @return {string|Object}     返回key对应的value，不传key，则返回所有cookie的键值对
     */

  }, {
    key: "getJSON",
    value: function getJSON(key) {
      return _jsCookie.default.getJSON(key);
    }
    /**
     * 设置cookie
     * @param {string} key
     * @param {string|number} val
     * @param {?Object} options cookie的相关参数设置
     * @param {?string} options.domain 默认为当前二级域名
     * @param {?string} options.path 默认为'/'
     * @param {?number} options.expires 指缓存天数，默认为365
     * @example
     * cookie.set('test', 'abc')
     * cookie.set('test', 'abc', { expires: 1, path: '/' })
     */

  }, {
    key: "set",
    value: function set(key, val, options) {
      _jsCookie.default.set(key, val, options);
    }
    /**
     * 删除指定的cookie
     * @param  {string|Array} keys    要删除的cookie的键值
     * @param  {Object} options 同set方法的options参数
     */

  }, {
    key: "remove",
    value: function remove(keys, options) {
      keys = Array.isArray(keys) ? keys : [keys];
      keys.forEach(function (key) {
        _jsCookie.default.remove(key, options);
      });
    }
    /**
     * 使用方式同remove方法
     * @param  {string|Array} keys    要删除的cookie的键值
     * @param  {Object} options 同set方法的options参数
     */

  }, {
    key: "del",
    value: function del(keys, options) {
      this.remove(keys, options);
    }
    /**
     * 清空指定域名及指定path下的cookie
     * @param  {?boolean} force 是否执行清空cookie操作，不传或为false，仅作提醒，不执行清空操作
     */

  }, {
    key: "clear",
    value: function clear(force) {
      if (!force) {
        console.warn('I sure hope you know what you are doing.');
        return;
      }

      var values = this.get();
      this.remove(Object.keys(values));
    }
  }]);

  return Cookie;
}();

var _default = new Cookie();

exports.default = _default;