"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = escape;

/**
 * 字符串的转义,将`&`, `<`, `>`, `"`, `'`分别转义为`&amp;`, `&lt;`,  `&gt;`, `&quot;`, `&#x27;`
 * @memberof module:string
 * @param {string} text 处理前字符串
 * @return {string} 处理后的字符串
 * @example
 * const escape = require('sd-tools/string/escape')
 * escape('<hello>')
 * // '&lt;hello&gt;'
 */
function escape(text) {
  var _escape = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#x27;'
  };
  var escapeExpr = /(&|<|>|"|')/g;
  return ('' + text).replace(escapeExpr, function (m) {
    return _escape[m];
  });
}