"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getLength;

/**
 * 获取字符串长度，中文长度为2
 * @memberof module:string
 * @param {string} str 字符串
 * @return {number} 字符串长度
 * @example
 * const getLength = require('sd-tools/string/getLength')
 * getLength('水滴sd') // 6
 */
function getLength(str) {
  var len = 0;

  for (var i = 0; i < str.length; i++) {
    var c = str.charCodeAt(i); // 单字节加1

    if (c >= 0x0001 && c <= 0x007e || c >= 0xff60 && c <= 0xff9f) {
      len++;
    } else {
      len += 2;
    }
  }

  return len;
}