"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function getParameterByName(name, url) {
  name = name.replace(/\[/, '\\[').replace(/\]/, '\\]');
  url = url ? '?' + url.split('#')[0].split('?')[1] : window.location.search;
  var reg = new RegExp('[?&]' + name + '=([^&#]*)', 'g');
  var results = [];
  var matches;

  while ((matches = reg.exec(url)) != null) {
    results.push(matches[1].replace(/\+/g, ' '));
  }

  if (results.length <= 1) {
    return results.toString();
  }

  return results;
}

function removeParameter(url, parameters) {
  var urlparts = url.split('?');
  parameters = {}.toString.call(parameters) === '[object Array]' ? parameters : [parameters];

  if (urlparts.length >= 2) {
    var _ret = function () {
      var prefixes = parameters.map(function (parameter) {
        return encodeURIComponent(parameter) + '=';
      });
      var pars = urlparts[1].split(/[&;]/g);

      var _loop = function _loop(i) {
        if (prefixes.some(function (prefix) {
          return pars[i].lastIndexOf(prefix, 0) !== -1;
        })) {
          pars.splice(i, 1);
        }
      };

      for (var i = pars.length; i-- > 0;) {
        _loop(i);
      }

      url = urlparts[0] + '?' + pars.join('&');
      return {
        v: url
      };
    }();

    if (_typeof(_ret) === "object") return _ret.v;
  }

  return url;
}

function serializeParams() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var params = [];
  Object.keys(obj).forEach(function (key) {
    var values = Array.isArray(obj[key]) ? obj[key] : [obj[key]];
    values.forEach(function (value) {
      if (value !== '') {
        params.push("".concat(key, "=").concat(value));
      }
    });
  });
  return params.length ? '?' + params.join('&') : '';
}

function addParameter(url) {
  var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (!url || url.length === 0 || url.trim().indexOf('javascript') === 0) {
    return '';
  }

  var hashArray = url.split('#');
  var paraArray = hashArray[0].split('?');
  var para = {};

  if (paraArray[1]) {
    paraArray[1].split('&').forEach(function (item) {
      var tempArr = item.split('='); // 参数值中有等号，做处理

      para[tempArr[0]] = tempArr.slice(1).join('=');
    });
  } // 将需要添加的参数放入para对象


  Object.keys(obj).forEach(function (key) {
    para[key.trim()] = encodeURIComponent(obj[key]);
  }); // 重组url

  url = paraArray[0] + serializeParams(para);

  if (hashArray[1]) {
    return url + '#' + hashArray[1];
  }

  return url;
}

var _default = {
  get: getParameterByName,
  remove: removeParameter,
  add: addParameter
};
exports.default = _default;